diff --git a/targetcli/cli_live.py b/targetcli/cli_live.py
new file mode 100644
index 0000000..5c9d6da
--- /dev/null
+++ b/targetcli/cli_live.py
@@ -0,0 +1,141 @@
+'''
+This file is part of the LIO SCSI Target.
+
+Copyright (c) 2012-2014 by Datera, Inc.
+More information on www.datera.io.
+
+Original author: Jerome Martin <jxm@netiant.com>
+
+Datera and LIO are trademarks of Datera, Inc., which may be registered in some
+jurisdictions.
+
+Licensed under the Apache License, Version 2.0 (the "License"); you may
+not use this file except in compliance with the License. You may obtain
+a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+License for the specific language governing permissions and limitations
+under the License.
+'''
+import os, sys
+import pyparsing as pp
+
+from rtslib.config_filters import *
+from targetcli.cli import Cli, CliError
+from targetcli.cli_config import CliConfig
+from targetcli.cli_logger import logger as log
+from rtslib.config import Config, ConfigError
+
+# TODO Implement do_summary using tables + color
+# TODO Implement sum for PR
+# TODO Implement sum for initiator sessions
+# TODO Implement sum for alua metadata
+# TODO Implement sum + mgmt for fabric modules
+# TODO Implement sum for network BW + portals
+# TODO Implement sum for disk IO
+
+class CliLive(Cli):
+    '''
+    The lio target configuration command-line for live mode.
+    '''
+    history_path = os.path.expanduser("~/.targetcli/history_live.txt")
+    intro = ("\nWelcome to the lio target interactive shell.\n"
+             "Copyright (c) 2012-2014 by Datera, Inc.\n"
+             "Enter '?' to list available commands.\n")
+
+    def __init__(self, interactive=False):
+        Cli.__init__(self, interactive, self.history_path)
+        self.prompt = "live> "
+        self.do_resync()
+
+    def do_exit(self, options):
+        '''
+        exit
+
+        Exits the lio target configuration shell.
+        '''
+        options = self.parse(options, 'exit', '')
+        return True
+
+    def do_resync(self, options=''):
+        '''
+        resync
+
+        Re-synchronizes the cli with the live running configuration. This
+        could be useful in rare cases where manual changes have been made to
+        the underlying configfs structure for debugging purposes.
+        '''
+        options = self.parse(options, 'resync', '')
+        log.info("Syncing policy and configuration...")
+        # FIXME Investigate bug in ConfigTree code: error if loading live twice
+        # without recreating the Config object.
+        self.config = Config()
+        self.config.load_live()
+
+    def do_configure(self, options):
+        '''
+        configure
+
+        Switch to config mode. In this mode, you can safely edit a candidate
+        configuration for the system, and commit it only when it is ready.
+        '''
+        options = self.parse(options, 'configure', '')
+        if not self.interactive:
+            raise CliError("Cannot switch to config mode when running "
+                           "non-interactively.")
+        else:
+            self.save_history()
+            self.clear_history()
+            # FIXME Preserve CliConfig session state, notably undo history
+            CliConfig(interactive=True).cmdloop()
+            self.clear_history()
+            self.load_history()
+            self.do_resync()
+            log.warning("[live] Back to live mode")
+
+    def do_show(self, options):
+        '''
+        show [all] [PATH]
+
+        Shows the running live configuration for PATH.
+
+        Note that attributes with default values will be
+        filrered out by default, unless the all option is used.
+        '''
+        if options and options.split()[0] == 'all':
+            options = " ".join(options.split()[1:])
+            node_filter = lambda x:x
+        else:
+            node_filter = filter_no_default
+
+        config = self.config.dump(options, node_filter)
+        if config is None:
+            config = self.config.dump("%s .*" % options, node_filter)
+        if config is not None:
+            sys.stdout.write("%s\n" % config)
+        else:
+            log.error("No such path in current configuration: %s" % options)
+
+    def complete_show(self, text, line, begidx, endidx):
+        # TODO add all option
+        return self._complete_path(text, line, begidx, endidx)
+
+    def do_initialize_system(self, options):
+        '''
+        initialize_system
+
+        Loads and commits the system startup configuration if it exists.
+        '''
+        self.config.load(CliConfig.config_path)
+        do_it = self.yes_no("Load and commit the system startup configuration?"
+                            , False)
+        if do_it is not False:
+            log.info("Initializing LIO target...")
+            for msg in self.config.apply():
+                log.info(msg)
+        self.config.load_live()
+
diff --git a/targetcli/cli_logger.py b/targetcli/cli_logger.py
new file mode 100644
index 0000000..78e5687
--- /dev/null
+++ b/targetcli/cli_logger.py
@@ -0,0 +1,48 @@
+'''
+This file is part of the LIO SCSI Target.
+
+Copyright (c) 2012-2014 by Datera, Inc.
+More information on www.datera.io.
+
+Original author: Jerome Martin <jxm@netiant.com>
+
+Datera and LIO are trademarks of Datera, Inc., which may be registered in some
+jurisdictions.
+
+Licensed under the Apache License, Version 2.0 (the "License"); you may
+not use this file except in compliance with the License. You may obtain
+a copy of the License at
+
+    http://www.apache.org/licenses/LICENSE-2.0
+
+Unless required by applicable law or agreed to in writing, software
+distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+License for the specific language governing permissions and limitations
+under the License.
+'''
+import sys, logging
+
+class LogFormatter(logging.Formatter):
+
+    default_format = "LOG%(levelno)s: %(msg)s"
+    formats = {10: "DEBUG:%(module)s:%(lineno)s: %(msg)s",
+               20: "%(msg)s",
+               30: "\n### %(msg)s\n",
+               40: "*** %(msg)s",
+               50: "CRITICAL: %(msg)s"}
+
+    def __init__(self):
+        logging.Formatter.__init__(self)
+
+    def format(self, record):
+        self._fmt = self.formats.get(record.levelno, self.default_format)
+        return logging.Formatter.format(self, record) 
+
+logger = logging.getLogger("LioCli")
+logger.setLevel(logging.INFO)
+
+log_fmt = LogFormatter()
+log_handler = logging.StreamHandler(sys.stdout)
+log_handler.setFormatter(log_fmt)
+logging.root.addHandler(log_handler)
diff --git a/targetcli/ui_backstore.py b/targetcli/ui_backstore.py
index 43bc41f..4d4b2bd 100644
--- a/targetcli/ui_backstore.py
+++ b/targetcli/ui_backstore.py
@@ -2,7 +2,7 @@
 Implements the targetcli backstores related UI.
 
 This file is part of targetcli.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -16,14 +16,15 @@ WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 License for the specific language governing permissions and limitations
 under the License.
 '''
-
+import os
 from ui_node import UINode, UIRTSLibNode
 from rtslib import RTSRoot
 from rtslib import FileIOBackstore, IBlockBackstore
-from rtslib import PSCSIBackstore, RDDRBackstore, RDMCPBackstore
+from rtslib import PSCSIBackstore, RDMCPBackstore
 from rtslib import FileIOStorageObject, IBlockStorageObject
-from rtslib import PSCSIStorageObject, RDDRStorageObject, RDMCPStorageObject
+from rtslib import PSCSIStorageObject, RDMCPStorageObject
 from rtslib.utils import get_block_type, is_disk_partition
+from rtslib.utils import convert_human_to_bytes, convert_bytes_to_human
 from configshell import ExecutionError
 
 def dedup_so_name(storage_object):
@@ -52,15 +53,14 @@ class UIBackstores(UINode):
     def refresh(self):
         self._children = set([])
         UIPSCSIBackstore(self)
-        UIRDDRBackstore(self)
         UIRDMCPBackstore(self)
         UIFileIOBackstore(self)
         UIIBlockBackstore(self)
 
-
 class UIBackstore(UINode):
     '''
     A backstore UI.
+    Abstract Base Class, do not instantiate.
     '''
     def __init__(self, plugin, parent):
         UINode.__init__(self, plugin, parent)
@@ -92,7 +92,7 @@ class UIBackstore(UINode):
         return generate_wwn
 
     def prm_buffered(self, buffered):
-        generate_wwn = \
+        buffered = \
                 self.ui_eval_param(buffered, 'bool', True)
         if buffered:
             self.shell.log.info("Using buffered mode.")
@@ -119,7 +119,7 @@ class UIBackstore(UINode):
         else:
             hba = child.rtsnode.backstore
             child.rtsnode.delete()
-            if not hba.storage_objects:
+            if not list(hba.storage_objects):
                 hba.delete()
             self.remove_child(child)
             self.shell.log.info("Deleted storage object %s." % name)
@@ -194,6 +194,11 @@ class UIPSCSIBackstore(UIBackstore):
         self.assert_root()
         self.assert_available_so_name(name)
         backstore = PSCSIBackstore(self.next_hba_index(), mode='create')
+
+        if get_block_type(dev) is not None or is_disk_partition(dev):
+            self.shell.log.info("Note: block backstore recommended for "
+                                "SCSI block devices")
+
         try:
             so = PSCSIStorageObject(backstore, name, dev)
         except Exception, exception:
@@ -204,47 +209,6 @@ class UIPSCSIBackstore(UIBackstore):
                             % (name, dev))
         return self.new_node(ui_so)
 
-
-class UIRDDRBackstore(UIBackstore):
-    '''
-    RDDR backstore UI.
-    '''
-    def __init__(self, parent):
-        UIBackstore.__init__(self, 'rd_dr', parent)
-
-    def ui_command_create(self, name, size, generate_wwn=None):
-        '''
-        Creates an RDDR storage object. I{size} is the size of the ramdisk, and
-        the optional I{generate_wwn} parameter is a boolean specifying whether
-        or not we should generate a T10 wwn serial for the unit (by default,
-        yes).
-
-        SIZE SYNTAX
-        ===========
-        - If size is an int, it represents a number of bytes.
-        - If size is a string, the following units can be used:
-            - B{B} or no unit present for bytes
-            - B{k}, B{K}, B{kB}, B{KB} for kB (kilobytes)
-            - B{m}, B{M}, B{mB}, B{MB} for MB (megabytes)
-            - B{g}, B{G}, B{gB}, B{GB} for GB (gigabytes)
-            - B{t}, B{T}, B{tB}, B{TB} for TB (terabytes)
-        '''
-        self.assert_root()
-        self.assert_available_so_name(name)
-        backstore = RDDRBackstore(self.next_hba_index(), mode='create')
-        try:
-            so = RDDRStorageObject(backstore, name, size,
-                                   self.prm_gen_wwn(generate_wwn))
-
-        except Exception, exception:
-            backstore.delete()
-            raise exception
-        ui_so = UIStorageObject(so, self)
-        self.shell.log.info("Created rd_dr ramdisk %s with size %s."
-                            % (name, size))
-        return self.new_node(ui_so)
-
-
 class UIRDMCPBackstore(UIBackstore):
     '''
     RDMCP backstore UI.
@@ -252,7 +216,7 @@ class UIRDMCPBackstore(UIBackstore):
     def __init__(self, parent):
         UIBackstore.__init__(self, 'rd_mcp', parent)
 
-    def ui_command_create(self, name, size, generate_wwn=None):
+    def ui_command_create(self, name, size, generate_wwn=None, nullio=None):
         '''
         Creates an RDMCP storage object. I{size} is the size of the ramdisk,
         and the optional I{generate_wwn} parameter is a boolean specifying
@@ -272,9 +236,11 @@ class UIRDMCPBackstore(UIBackstore):
         self.assert_root()
         self.assert_available_so_name(name)
         backstore = RDMCPBackstore(self.next_hba_index(), mode='create')
+        nullio = self.ui_eval_param(nullio, 'bool', False)
         try:
             so = RDMCPStorageObject(backstore, name, size,
-                                    self.prm_gen_wwn(generate_wwn))
+                                    self.prm_gen_wwn(generate_wwn),
+                                    nullio=nullio)
 
         except Exception, exception:
             backstore.delete()
@@ -282,6 +248,9 @@ class UIRDMCPBackstore(UIBackstore):
         ui_so = UIStorageObject(so, self)
         self.shell.log.info("Created rd_mcp ramdisk %s with size %s."
                             % (name, size))
+        if nullio and not so.nullio:
+            self.shell.log.warning("nullio ramdisk is not supported by this "
+                                   "kernel version, created with nullio=false")
         return self.new_node(ui_so)
 
 
@@ -292,8 +261,26 @@ class UIFileIOBackstore(UIBackstore):
     def __init__(self, parent):
         UIBackstore.__init__(self, 'fileio', parent)
 
+    def _create_file(self, filename, size, sparse=True):
+        f = open(filename, "w+")
+        try:
+            if sparse:
+                os.ftruncate(f.fileno(), size)
+            else:
+                self.shell.log.info("Writing %s bytes" % size)
+                while size > 0:
+                    write_size = min(size, 1024)
+                    f.write("\0" * write_size)
+                    size -= write_size
+        except IOError:
+            f.close()
+            os.remove(filename)
+            raise ExecutionError("Could not expand file to size")
+        f.close()
+
     def ui_command_create(self, name, file_or_dev, size=None,
-                          generate_wwn=None, buffered=None):
+                          generate_wwn=None, buffered=None, sparse=None):
+
         '''
         Creates a FileIO storage object. If I{file_or_dev} is a path to a
         regular file to be used as backend, then the I{size} parameter is
@@ -303,8 +290,11 @@ class UIFileIOBackstore(UIBackstore):
         a block device.  The optional I{generate_wwn} parameter is a boolean
         specifying whether or not we should generate a T10 wwn Serial for the
         unit (by default, yes).  The I{buffered} parameter is a boolean stating
-        whether or not to enable buffered mode. It is disabled by default
-        (synchronous mode).
+        whether or not to enable buffered mode. It is enabled by default
+        (asynchronous mode). The I{sparse} parameter is only applicable when
+        creating a new backing file. It is a boolean stating if the
+        created file should be created as a sparse file (the default), or
+        fully initialized.
 
         SIZE SYNTAX
         ===========
@@ -319,10 +309,16 @@ class UIFileIOBackstore(UIBackstore):
         self.assert_root()
         self.assert_available_so_name(name)
         self.shell.log.debug("Using params size=%s generate_wwn=%s buffered=%s"
-                             % (size, generate_wwn, buffered))
+                             " sparse=%s"
+                             % (size, generate_wwn, buffered, sparse))
+
+        sparse = self.ui_eval_param(sparse, 'bool', True)
+
+        backstore = FileIOBackstore(self.next_hba_index(), mode='create')
+
         is_dev = get_block_type(file_or_dev) is not None \
                 or is_disk_partition(file_or_dev)
-                
+
         if size is None and is_dev:
             backstore = FileIOBackstore(self.next_hba_index(), mode='create')
             try:
@@ -335,6 +331,8 @@ class UIFileIOBackstore(UIBackstore):
                 raise exception
             self.shell.log.info("Created fileio %s with size %s."
                                 % (name, size))
+            self.shell.log.info("Note: block backstore preferred for "
+                                " best results.")
             ui_so = UIStorageObject(so, self)
             return self.new_node(ui_so)
         elif size is not None and not is_dev:
@@ -352,8 +350,23 @@ class UIFileIOBackstore(UIBackstore):
             ui_so = UIStorageObject(so, self)
             return self.new_node(ui_so)
         else:
-            self.shell.log.error("For fileio, you must either specify both a "
-                                 + "file and a size, or just a device path.")
+            # use given file size only if backing file does not exist
+            if os.path.isfile(file_or_dev):
+                new_size = str(os.path.getsize(file_or_dev))
+                if size:
+                    self.shell.log.info("%s exists, using its size (%s bytes)"
+                                        " instead"
+                                        % (file_or_dev, new_size))
+                size = new_size
+            elif os.path.exists(file_or_dev):
+                raise ExecutionError("Path %s exists but is not a file" % file_or_dev)
+            else:
+                # create file and extend to given file size
+                if not size:
+                    raise ExecutionError("Attempting to create file for new" +
+                                         " fileio backstore, need a size")
+                self._create_file(file_or_dev, convert_human_to_bytes(size),
+                                  sparse)
 
 
 class UIIBlockBackstore(UIBackstore):
@@ -388,6 +401,7 @@ class UIIBlockBackstore(UIBackstore):
 class UIStorageObject(UIRTSLibNode):
     '''
     A storage object UI.
+    Abstract Base Class, do not instantiate.
     '''
     def __init__(self, storage_object, parent):
         name = storage_object.name
@@ -417,17 +431,25 @@ class UIStorageObject(UIRTSLibNode):
         legacy = []
         if self.rtsnode.name != self.name:
             legacy.append("ADDED SUFFIX")
-        if len(self.rtsnode.backstore.storage_objects) > 1:
+        if len(list(self.rtsnode.backstore.storage_objects)) > 1:
             legacy.append("SHARED HBA")
 
         if legacy:
             errors.append("LEGACY: " + ", ".join(legacy))
 
+        size = convert_bytes_to_human(getattr(so, "size", 0))
+        nullio_str = ""
+        try:
+            if so.nullio:
+                nullio_str = " (nullio)"
+        except AttributeError:
+            pass
+
         if errors:
             msg = ", ".join(errors)
             if path:
                 msg += " (%s %s)" % (path, so.status)
             return (msg, False)
         else:
-            return ("%s %s" % (path, so.status), True)
+            return ("%s %s%s%s" % (path, size, so.status, nullio_str), True)
 
diff --git a/targetcli/ui_backstore_legacy.py b/targetcli/ui_backstore_legacy.py
index 2d46fcd..514cabc 100644
--- a/targetcli/ui_backstore_legacy.py
+++ b/targetcli/ui_backstore_legacy.py
@@ -2,7 +2,7 @@
 Implements the targetcli backstores related UI.
 
 his file is part of targetcli.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -20,9 +20,9 @@ under the License.
 from ui_node import UINode, UIRTSLibNode
 from rtslib import RTSRoot
 from rtslib import FileIOBackstore, IBlockBackstore
-from rtslib import PSCSIBackstore, RDDRBackstore, RDMCPBackstore
+from rtslib import PSCSIBackstore, RDMCPBackstore
 from rtslib import FileIOStorageObject, IBlockStorageObject
-from rtslib import PSCSIStorageObject, RDDRStorageObject, RDMCPStorageObject
+from rtslib import PSCSIStorageObject, RDMCPStorageObject
 from rtslib.utils import get_block_type, is_disk_partition
 
 class UIBackstoresLegacy(UINode):
@@ -40,8 +40,6 @@ class UIBackstoresLegacy(UINode):
             backstore_plugin = backstore.plugin
             if backstore_plugin == 'pscsi':
                 UIPSCSIBackstoreLegacy(backstore, self)
-            elif backstore_plugin == 'rd_dr':
-                UIRDDRBackstoreLegacy(backstore, self)
             elif backstore_plugin == 'rd_mcp':
                 UIRDMCPBackstoreLegacy(backstore, self)
             elif backstore_plugin == 'fileio':
@@ -92,18 +90,11 @@ class UIBackstoresLegacy(UINode):
         block I/O with various methods (synchronous or asynchronous) and
         (buffered or direct).
 
-        B{rd_dr}
-        -------
-        This I{backstore_plugin} provides the same level of SCSI emulation than
-        the I{fileio} and I{iblock} backstores, but uses a B{ramdisk}, based on
-        direct memory mapping. It is the fastest of all backstores, and is
-        typically used for bandwidth testing.
-
         B{rd_mcp}
         --------
-        This I{backstore_plugin} is a bit slower than B{rd_dr}, but more robust
-        with multiple initiators, with a separate memory mapping using memory
-        copy. Also typically used for bandwidth testing.
+        This I{backstore_plugin} uses a ramdisk with a separate
+        mapping using memory copy. Typically used for bandwidth
+        testing.
 
         EXAMPLE
         =======
@@ -134,9 +125,6 @@ class UIBackstoresLegacy(UINode):
         if backstore_plugin == 'pscsi':
             backstore = PSCSIBackstore(backstore_index, mode='create')
             return self.new_node(UIPSCSIBackstoreLegacy(backstore, self))
-        elif backstore_plugin == 'rd_dr':
-            backstore = RDDRBackstore(backstore_index, mode='create')
-            return self.new_node(UIRDDRBackstoreLegacy(backstore, self))
         elif backstore_plugin == 'rd_mcp':
             backstore = RDMCPBackstore(backstore_index, mode='create')
             return self.new_node(UIRDMCPBackstoreLegacy(backstore, self))
@@ -166,7 +154,7 @@ class UIBackstoresLegacy(UINode):
         @rtype: list of str
         '''
         if current_param == 'backstore_plugin':
-            plugins = ['pscsi', 'rd_dr', 'rd_mcp', 'fileio', 'iblock']
+            plugins = ['pscsi', 'rd_mcp', 'fileio', 'iblock']
             completions = [plugin for plugin in plugins
                            if plugin.startswith(text)]
         else:
@@ -339,37 +327,6 @@ class UIPSCSIBackstoreLegacy(UIBackstoreLegacy):
                             % (name, dev))
         return self.new_node(ui_so)
 
-
-class UIRDDRBackstoreLegacy(UIBackstoreLegacy):
-    '''
-    RDDR backstore UI.
-    '''
-    def ui_command_create(self, name, size, generate_wwn=None):
-        '''
-        Creates an RDDR storage object. I{size} is the size of the ramdisk, and
-        the optional I{generate_wwn} parameter is a boolean specifying whether
-        or not we should generate a T10 wwn serial for the unit (by default,
-        yes).
-
-        SIZE SYNTAX
-        ===========
-        - If size is an int, it represents a number of bytes.
-        - If size is a string, the following units can be used:
-            - B{B} or no unit present for bytes
-            - B{k}, B{K}, B{kB}, B{KB} for kB (kilobytes)
-            - B{m}, B{M}, B{mB}, B{MB} for MB (megabytes)
-            - B{g}, B{G}, B{gB}, B{GB} for GB (gigabytes)
-            - B{t}, B{T}, B{tB}, B{TB} for TB (terabytes)
-        '''
-        self.assert_root()
-        so = RDDRStorageObject(self.rtsnode, name, size,
-                               self.prm_gen_wwn(generate_wwn))
-        ui_so = UIStorageObjectLegacy(so, self)
-        self.shell.log.info("Created rd_dr ramdisk %s with size %s."
-                            % (name, size))
-        return self.new_node(ui_so)
-
-
 class UIRDMCPBackstoreLegacy(UIBackstoreLegacy):
     '''
     RDMCP backstore UI.
diff --git a/targetcli/ui_node.py b/targetcli/ui_node.py
index 52079c1..9b90feb 100644
--- a/targetcli/ui_node.py
+++ b/targetcli/ui_node.py
@@ -2,7 +2,7 @@
 Implements the targetcli base UI node.
 
 This file is part of targetcli.
-Copyright (c) 2011-2013 by Datera, Inc
+Copyright (c) 2011-2014 by Datera, Inc
 
 Licensed under the Apache License, Version 2.0 (the "License"); you may
 not use this file except in compliance with the License. You may obtain
@@ -18,11 +18,13 @@ under the License.
 '''
 
 from configshell import ConfigNode, ExecutionError
-from rtslib import RTSLibError, RTSRoot
+from rtslib import RTSLibError, RTSRoot, Config
 from subprocess import PIPE, Popen
 from os.path import isfile
 from os import getuid
 
+STARTUP_CONFIG = "/etc/target/scsi_target.lio"
+
 def exec3(cmd):
     '''
     Executes a shell command **cmd** and returns
@@ -44,8 +46,8 @@ class UINode(ConfigNode):
         ConfigNode.__init__(self, name, parent, shell)
         self.cfs_cwd = RTSRoot.configfs_dir
         self.define_config_group_param(
-            'global', 'auto_enable_tpgt', 'bool',
-            'If true, automatically enables TPGTs upon creation.')
+            'global', 'auto_enable_tpg', 'bool',
+            'If true, automatically enables TPGs upon creation.')
         self.define_config_group_param(
             'global', 'auto_add_mapped_luns', 'bool',
             'If true, automatically create node ACLs mapped LUNs '
@@ -64,7 +66,7 @@ class UINode(ConfigNode):
         node's as_root attribute is False.
         '''
         root_node = self.get_root()
-        if hasattr(root_node, 'as_root') and not self.get_root().as_root:
+        if hasattr(root_node, 'as_root') and not root_node.as_root:
             raise ExecutionError("This privileged command is disabled: "
                                  + "you are not root.")
 
@@ -100,7 +102,7 @@ class UINode(ConfigNode):
             result = ConfigNode.execute_command(self, command,
                                                 pparams, kparams)
         except RTSLibError, msg:
-            self.shell.log.error(msg)
+            self.shell.log.error(str(msg))
         else:
             self.shell.log.debug("Command %s succeeded." % command)
             return result
@@ -109,34 +111,30 @@ class UINode(ConfigNode):
         '''
         Exits the command line interface.
         '''
-        config_needs_save = False
-        config_paths = {'tcm': "/etc/target/tcm_start.sh",
-                        'lio': "/etc/target/lio_start.sh"}
-        for mod_name, config_path in config_paths.items():
-            saved_config = ''
-            live_config = exec3("%s_dump --stdout" % mod_name)[1]
-            if isfile(config_path):
-                with open(config_path) as config_fh:
-                    saved_config = config_fh.read()
+        if getuid() == 0:
+            config = Config()
+            if isfile(STARTUP_CONFIG):
+                config.load(STARTUP_CONFIG, allow_new_attrs=True)
+            saved_config = config.dump()
+            config.load_live()
+            live_config = config.dump()
             if saved_config != live_config:
-                config_needs_save = True
-                break
-
-        if config_needs_save and getuid() == 0:
-            self.shell.con.display("There are unsaved configuration changes.\n"
-                                   "If you exit now, configuration will not "
-                                   "be updated and changes will be lost upon "
-                                   "reboot.")
-            try:
-                input = raw_input("Type 'exit' if you want to exit anyway: ")
-            except EOFError:
-                input = None
-                self.shell.con.display('')
-            if input == "exit":
-                return 'EXIT'
+                self.shell.con.display("There are unsaved configuration changes.\n"
+                                       "If you exit now, configuration will not "
+                                       "be updated and changes will be lost upon "
+                                       "reboot.")
+                try:
+                    input = raw_input("Type 'exit' if you want to exit anyway: ")
+                except EOFError:
+                    input = None
+                    self.shell.con.display('')
+                if input == "exit":
+                    return 'EXIT'
+                else:
+                    self.shell.log.warning("Aborted exit, use 'saveconfig' to "
+                                           "save the current configuration.")
             else:
-                self.shell.log.warning("Aborted exit, use 'saveconfig' to "
-                                       "save the current configuration.")
+                return 'EXIT'
         else:
             return 'EXIT'
 
@@ -206,14 +204,16 @@ class UIRTSLibNode(UINode):
         Overrides the parent's execute_command() to check if the underlying
         RTSLib object still exists before returning.
         '''
-        if not self.rtsnode.exists:
+        try:
+            self.rtsnode._check_self()
+        except RTSLibError:
             self.shell.log.error("The underlying rtslib object for "
                                  + "%s does not exist." % self.path)
             root = self.get_root()
             root.refresh()
             return root
-        else:
-            return UINode.execute_command(self, command, pparams, kparams)
+
+        return UINode.execute_command(self, command, pparams, kparams)
 
     def ui_getgroup_attribute(self, attribute):
         '''
